# equinix-metal
desc

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 0.1.0
- Build package: org.openapitools.codegen.languages.PythonNextgenClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/equinix-labs/metal-python.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/equinix-labs/metal-python.git`)

Then import the package:
```python
import equinix_metal
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import equinix_metal
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import equinix_metal
from equinix_metal.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.equinix.com/metal/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = equinix_metal.Configuration(
    host = "https://api.equinix.com/metal/v1"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: x_auth_token
configuration.api_key['x_auth_token'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x_auth_token'] = 'Bearer'


# Enter a context with an instance of the API client
with equinix_metal.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = equinix_metal.DevicesApi(api_client)
    id = 'id_example' # str | Project UUID
    create_device_request = equinix_metal.CreateDeviceRequest() # CreateDeviceRequest | Device to create

    try:
        # Create a device
        api_response = api_instance.create_device(id, create_device_request)
        print("The response of DevicesApi->create_device:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling DevicesApi->create_device: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.equinix.com/metal/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DevicesApi* | [**create_device**](docs/DevicesApi.md#create_device) | **POST** /projects/{id}/devices | Create a device
*DevicesApi* | [**create_ip_assignment**](docs/DevicesApi.md#create_ip_assignment) | **POST** /devices/{id}/ips | Create an ip assignment
*DevicesApi* | [**delete_device**](docs/DevicesApi.md#delete_device) | **DELETE** /devices/{id} | Delete the device
*DevicesApi* | [**find_device_by_id**](docs/DevicesApi.md#find_device_by_id) | **GET** /devices/{id} | Retrieve a device
*DevicesApi* | [**find_ip_assignments**](docs/DevicesApi.md#find_ip_assignments) | **GET** /devices/{id}/ips | Retrieve all ip assignments
*DevicesApi* | [**find_organization_devices**](docs/DevicesApi.md#find_organization_devices) | **GET** /organizations/{id}/devices | Retrieve all devices of an organization
*DevicesApi* | [**find_project_devices**](docs/DevicesApi.md#find_project_devices) | **GET** /projects/{id}/devices | Retrieve all devices of a project
*DevicesApi* | [**update_device**](docs/DevicesApi.md#update_device) | **PUT** /devices/{id} | Update the device
*IPAddressesApi* | [**delete_ip_address**](docs/IPAddressesApi.md#delete_ip_address) | **DELETE** /ips/{id} | Unassign an ip address
*IPAddressesApi* | [**find_ip_address_by_id**](docs/IPAddressesApi.md#find_ip_address_by_id) | **GET** /ips/{id} | Retrieve an ip address
*IPAddressesApi* | [**find_ip_address_customdata**](docs/IPAddressesApi.md#find_ip_address_customdata) | **GET** /ips/{id}/customdata | Retrieve the custom metadata of an IP Reservation or IP Assignment
*IPAddressesApi* | [**find_ip_availabilities**](docs/IPAddressesApi.md#find_ip_availabilities) | **GET** /ips/{id}/available | Retrieve all available subnets of a particular reservation
*IPAddressesApi* | [**find_ip_reservations**](docs/IPAddressesApi.md#find_ip_reservations) | **GET** /projects/{id}/ips | Retrieve all ip reservations
*IPAddressesApi* | [**request_ip_reservation**](docs/IPAddressesApi.md#request_ip_reservation) | **POST** /projects/{id}/ips | Requesting IP reservations
*IPAddressesApi* | [**update_ip_address**](docs/IPAddressesApi.md#update_ip_address) | **PATCH** /ips/{id} | Update an ip address
*OrganizationsApi* | [**create_organization**](docs/OrganizationsApi.md#create_organization) | **POST** /organizations | Create an organization
*OrganizationsApi* | [**create_organization_project**](docs/OrganizationsApi.md#create_organization_project) | **POST** /organizations/{id}/projects | Create a project for the organization
*OrganizationsApi* | [**delete_organization**](docs/OrganizationsApi.md#delete_organization) | **DELETE** /organizations/{id} | Delete the organization
*OrganizationsApi* | [**find_organization_by_id**](docs/OrganizationsApi.md#find_organization_by_id) | **GET** /organizations/{id} | Retrieve an organization&#39;s details
*OrganizationsApi* | [**find_organization_projects**](docs/OrganizationsApi.md#find_organization_projects) | **GET** /organizations/{id}/projects | Retrieve all projects of an organization
*OrganizationsApi* | [**find_organizations**](docs/OrganizationsApi.md#find_organizations) | **GET** /organizations | Retrieve all organizations
*OrganizationsApi* | [**update_organization**](docs/OrganizationsApi.md#update_organization) | **PUT** /organizations/{id} | Update the organization
*ProjectsApi* | [**create_project**](docs/ProjectsApi.md#create_project) | **POST** /projects | Create a project
*ProjectsApi* | [**delete_project**](docs/ProjectsApi.md#delete_project) | **DELETE** /projects/{id} | Delete the project
*ProjectsApi* | [**find_ip_reservation_customdata**](docs/ProjectsApi.md#find_ip_reservation_customdata) | **GET** /projects/{project_id}/ips/{id}/customdata | Retrieve the custom metadata of an IP Reservation
*ProjectsApi* | [**find_project_by_id**](docs/ProjectsApi.md#find_project_by_id) | **GET** /projects/{id} | Retrieve a project
*ProjectsApi* | [**find_projects**](docs/ProjectsApi.md#find_projects) | **GET** /projects | Retrieve all projects
*ProjectsApi* | [**update_project**](docs/ProjectsApi.md#update_project) | **PUT** /projects/{id} | Update the project
*VRFsApi* | [**find_vrf_ip_reservation**](docs/VRFsApi.md#find_vrf_ip_reservation) | **GET** /vrfs/{vrf_id}/ips/{id} | Retrieve all VRF IP Reservations in the VRF


## Documentation For Models

 - [Address](docs/Address.md)
 - [BondPortData](docs/BondPortData.md)
 - [Coordinates](docs/Coordinates.md)
 - [CreateDeviceRequest](docs/CreateDeviceRequest.md)
 - [Device](docs/Device.md)
 - [DeviceActionsInner](docs/DeviceActionsInner.md)
 - [DeviceCreateInFacilityInput](docs/DeviceCreateInFacilityInput.md)
 - [DeviceCreateInMetroInput](docs/DeviceCreateInMetroInput.md)
 - [DeviceCreateInput](docs/DeviceCreateInput.md)
 - [DeviceCreateInputIpAddressesInner](docs/DeviceCreateInputIpAddressesInner.md)
 - [DeviceCreatedBy](docs/DeviceCreatedBy.md)
 - [DeviceList](docs/DeviceList.md)
 - [DeviceMetro](docs/DeviceMetro.md)
 - [DeviceProject](docs/DeviceProject.md)
 - [DeviceProjectLite](docs/DeviceProjectLite.md)
 - [DeviceUpdateInput](docs/DeviceUpdateInput.md)
 - [Error](docs/Error.md)
 - [Event](docs/Event.md)
 - [Facility](docs/Facility.md)
 - [FacilityInput](docs/FacilityInput.md)
 - [FacilityInputFacility](docs/FacilityInputFacility.md)
 - [FindIPAddressById200Response](docs/FindIPAddressById200Response.md)
 - [Href](docs/Href.md)
 - [IPAssignment](docs/IPAssignment.md)
 - [IPAssignmentInput](docs/IPAssignmentInput.md)
 - [IPAssignmentList](docs/IPAssignmentList.md)
 - [IPAssignmentMetro](docs/IPAssignmentMetro.md)
 - [IPAssignmentUpdateInput](docs/IPAssignmentUpdateInput.md)
 - [IPAvailabilitiesList](docs/IPAvailabilitiesList.md)
 - [IPReservation](docs/IPReservation.md)
 - [IPReservationFacility](docs/IPReservationFacility.md)
 - [IPReservationList](docs/IPReservationList.md)
 - [IPReservationListIpAddressesInner](docs/IPReservationListIpAddressesInner.md)
 - [IPReservationMetro](docs/IPReservationMetro.md)
 - [IPReservationRequestInput](docs/IPReservationRequestInput.md)
 - [Meta](docs/Meta.md)
 - [MetalGatewayLite](docs/MetalGatewayLite.md)
 - [Metro](docs/Metro.md)
 - [MetroInput](docs/MetroInput.md)
 - [OperatingSystem](docs/OperatingSystem.md)
 - [Organization](docs/Organization.md)
 - [OrganizationInput](docs/OrganizationInput.md)
 - [OrganizationList](docs/OrganizationList.md)
 - [ParentBlock](docs/ParentBlock.md)
 - [Plan](docs/Plan.md)
 - [PlanAvailableInInner](docs/PlanAvailableInInner.md)
 - [PlanAvailableInInnerPrice](docs/PlanAvailableInInnerPrice.md)
 - [PlanAvailableInMetrosInner](docs/PlanAvailableInMetrosInner.md)
 - [PlanSpecs](docs/PlanSpecs.md)
 - [PlanSpecsCpusInner](docs/PlanSpecsCpusInner.md)
 - [PlanSpecsDrivesInner](docs/PlanSpecsDrivesInner.md)
 - [PlanSpecsFeatures](docs/PlanSpecsFeatures.md)
 - [PlanSpecsNicsInner](docs/PlanSpecsNicsInner.md)
 - [Port](docs/Port.md)
 - [PortData](docs/PortData.md)
 - [Project](docs/Project.md)
 - [ProjectCreateFromRootInput](docs/ProjectCreateFromRootInput.md)
 - [ProjectCreateInput](docs/ProjectCreateInput.md)
 - [ProjectList](docs/ProjectList.md)
 - [ProjectUpdateInput](docs/ProjectUpdateInput.md)
 - [RequestIPReservation201Response](docs/RequestIPReservation201Response.md)
 - [RequestIPReservationRequest](docs/RequestIPReservationRequest.md)
 - [SSHKeyInput](docs/SSHKeyInput.md)
 - [User](docs/User.md)
 - [UserLite](docs/UserLite.md)
 - [VirtualNetwork](docs/VirtualNetwork.md)
 - [Vrf](docs/Vrf.md)
 - [VrfIpReservation](docs/VrfIpReservation.md)
 - [VrfIpReservationCreateInput](docs/VrfIpReservationCreateInput.md)


## Documentation For Authorization


## x_auth_token

- **Type**: API key
- **API key parameter name**: X-Auth-Token
- **Location**: HTTP header


## Author

support@equinixmetal.com


