# coding: utf-8

"""
    Metal API

    desc  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@equinixmetal.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from equinix_metal.models.device_create_in_facility_input import DeviceCreateInFacilityInput
from equinix_metal.models.device_create_in_metro_input import DeviceCreateInMetroInput
from typing import Any, List
from pydantic import StrictStr, Field

CREATEDEVICEREQUEST_ONE_OF_SCHEMAS = ["DeviceCreateInFacilityInput", "DeviceCreateInMetroInput"]

class CreateDeviceRequest(BaseModel):
    """
    CreateDeviceRequest
    """
    # data type: DeviceCreateInMetroInput
    oneof_schema_1_validator: Optional[DeviceCreateInMetroInput] = None
    # data type: DeviceCreateInFacilityInput
    oneof_schema_2_validator: Optional[DeviceCreateInFacilityInput] = None
    actual_instance: Any
    one_of_schemas: List[str] = Field(CREATEDEVICEREQUEST_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = cls()
        error_messages = []
        match = 0
        # validate data type: DeviceCreateInMetroInput
        if type(v) is not DeviceCreateInMetroInput:
            error_messages.append(f"Error! Input type `{type(v)}` is not `DeviceCreateInMetroInput`")
        else:
            match += 1

        # validate data type: DeviceCreateInFacilityInput
        if type(v) is not DeviceCreateInFacilityInput:
            error_messages.append(f"Error! Input type `{type(v)}` is not `DeviceCreateInFacilityInput`")
        else:
            match += 1

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into CreateDeviceRequest with oneOf schemas: DeviceCreateInFacilityInput, DeviceCreateInMetroInput. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into CreateDeviceRequest with oneOf schemas: DeviceCreateInFacilityInput, DeviceCreateInMetroInput. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> CreateDeviceRequest:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> CreateDeviceRequest:
        """Returns the object represented by the json string"""
        instance = cls()
        error_messages = []
        match = 0

        # deserialize data into DeviceCreateInMetroInput
        try:
            instance.actual_instance = DeviceCreateInMetroInput.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))
        # deserialize data into DeviceCreateInFacilityInput
        try:
            instance.actual_instance = DeviceCreateInFacilityInput.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into CreateDeviceRequest with oneOf schemas: DeviceCreateInFacilityInput, DeviceCreateInMetroInput. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into CreateDeviceRequest with oneOf schemas: DeviceCreateInFacilityInput, DeviceCreateInMetroInput. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_json()
        else:
            return "null"

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_dict()
        else:
            return dict()

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

