# coding: utf-8

"""
    Metal API

    desc  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@equinixmetal.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist, validator
from equinix_metal.models.plan_available_in_inner import PlanAvailableInInner
from equinix_metal.models.plan_available_in_metros_inner import PlanAvailableInMetrosInner
from equinix_metal.models.plan_specs import PlanSpecs

class Plan(BaseModel):
    """
    Plan
    """
    available_in: Optional[conlist(PlanAvailableInInner)] = Field(None, description="Shows which facilities the plan is available in, and the facility-based price if it is different from the default price.")
    available_in_metros: Optional[conlist(PlanAvailableInMetrosInner)] = Field(None, description="Shows which metros the plan is available in, and the metro-based price if it is different from the default price.")
    var_class: Optional[StrictStr] = Field(None, alias="class")
    deployment_types: Optional[conlist(StrictStr, min_items=0)] = None
    description: Optional[StrictStr] = None
    href: Optional[StrictStr] = None
    id: Optional[StrictStr] = None
    legacy: Optional[StrictBool] = None
    line: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    pricing: Optional[Dict[str, Any]] = None
    slug: Optional[StrictStr] = None
    specs: Optional[PlanSpecs] = None
    type: Optional[StrictStr] = Field(None, description="The plan type")
    __properties = ["available_in", "available_in_metros", "class", "deployment_types", "description", "href", "id", "legacy", "line", "name", "pricing", "slug", "specs", "type"]

    @validator('deployment_types')
    def deployment_types_validate_enum(cls, v):
        if v is None:
            return v
        for i in v:
            if i not in ('on_demand', 'spot_market'):
                raise ValueError("each list item must be one of ('on_demand', 'spot_market')")
        return v

    @validator('line')
    def line_validate_enum(cls, v):
        if v is None:
            return v
        if v not in ('baremetal'):
            raise ValueError("must be one of enum values ('baremetal')")
        return v

    @validator('type')
    def type_validate_enum(cls, v):
        if v is None:
            return v
        if v not in ('standard', 'workload_optimized', 'custom'):
            raise ValueError("must be one of enum values ('standard', 'workload_optimized', 'custom')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Plan:
        """Create an instance of Plan from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in available_in (list)
        _items = []
        if self.available_in:
            for _item in self.available_in:
                if _item:
                    _items.append(_item.to_dict())
            _dict['available_in'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in available_in_metros (list)
        _items = []
        if self.available_in_metros:
            for _item in self.available_in_metros:
                if _item:
                    _items.append(_item.to_dict())
            _dict['available_in_metros'] = _items
        # override the default output from pydantic by calling `to_dict()` of specs
        if self.specs:
            _dict['specs'] = self.specs.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Plan:
        """Create an instance of Plan from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return Plan.parse_obj(obj)

        _obj = Plan.parse_obj({
            "available_in": [PlanAvailableInInner.from_dict(_item) for _item in obj.get("available_in")] if obj.get("available_in") is not None else None,
            "available_in_metros": [PlanAvailableInMetrosInner.from_dict(_item) for _item in obj.get("available_in_metros")] if obj.get("available_in_metros") is not None else None,
            "var_class": obj.get("class"),
            "deployment_types": obj.get("deployment_types"),
            "description": obj.get("description"),
            "href": obj.get("href"),
            "id": obj.get("id"),
            "legacy": obj.get("legacy"),
            "line": obj.get("line"),
            "name": obj.get("name"),
            "pricing": obj.get("pricing"),
            "slug": obj.get("slug"),
            "specs": PlanSpecs.from_dict(obj.get("specs")) if obj.get("specs") is not None else None,
            "type": obj.get("type")
        })
        return _obj

