# coding: utf-8

"""
    Metal API

    desc  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@equinixmetal.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, StrictStr, conlist
from equinix_metal.models.plan_specs_cpus_inner import PlanSpecsCpusInner
from equinix_metal.models.plan_specs_drives_inner import PlanSpecsDrivesInner
from equinix_metal.models.plan_specs_features import PlanSpecsFeatures
from equinix_metal.models.plan_specs_nics_inner import PlanSpecsNicsInner

class PlanSpecs(BaseModel):
    """
    PlanSpecs
    """
    cpus: Optional[conlist(PlanSpecsCpusInner)] = None
    drives: Optional[conlist(PlanSpecsDrivesInner)] = None
    features: Optional[PlanSpecsFeatures] = None
    href: Optional[StrictStr] = None
    nics: Optional[conlist(PlanSpecsNicsInner)] = None
    __properties = ["cpus", "drives", "features", "href", "nics"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PlanSpecs:
        """Create an instance of PlanSpecs from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in cpus (list)
        _items = []
        if self.cpus:
            for _item in self.cpus:
                if _item:
                    _items.append(_item.to_dict())
            _dict['cpus'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in drives (list)
        _items = []
        if self.drives:
            for _item in self.drives:
                if _item:
                    _items.append(_item.to_dict())
            _dict['drives'] = _items
        # override the default output from pydantic by calling `to_dict()` of features
        if self.features:
            _dict['features'] = self.features.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in nics (list)
        _items = []
        if self.nics:
            for _item in self.nics:
                if _item:
                    _items.append(_item.to_dict())
            _dict['nics'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PlanSpecs:
        """Create an instance of PlanSpecs from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return PlanSpecs.parse_obj(obj)

        _obj = PlanSpecs.parse_obj({
            "cpus": [PlanSpecsCpusInner.from_dict(_item) for _item in obj.get("cpus")] if obj.get("cpus") is not None else None,
            "drives": [PlanSpecsDrivesInner.from_dict(_item) for _item in obj.get("drives")] if obj.get("drives") is not None else None,
            "features": PlanSpecsFeatures.from_dict(obj.get("features")) if obj.get("features") is not None else None,
            "href": obj.get("href"),
            "nics": [PlanSpecsNicsInner.from_dict(_item) for _item in obj.get("nics")] if obj.get("nics") is not None else None
        })
        return _obj

