# coding: utf-8

"""
    Metal API

    desc  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: support@equinixmetal.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import json
import pprint
import re  # noqa: F401

from typing import Any, List, Optional
from pydantic import BaseModel, Field, StrictStr, ValidationError, validator
from equinix_metal.models.ip_reservation_request_input import IPReservationRequestInput
from equinix_metal.models.vrf_ip_reservation_create_input import VrfIpReservationCreateInput
from typing import Any, List
from pydantic import StrictStr, Field

REQUESTIPRESERVATIONREQUEST_ONE_OF_SCHEMAS = ["IPReservationRequestInput", "VrfIpReservationCreateInput"]

class RequestIPReservationRequest(BaseModel):
    """
    RequestIPReservationRequest
    """
    # data type: IPReservationRequestInput
    oneof_schema_1_validator: Optional[IPReservationRequestInput] = None
    # data type: VrfIpReservationCreateInput
    oneof_schema_2_validator: Optional[VrfIpReservationCreateInput] = None
    actual_instance: Any
    one_of_schemas: List[str] = Field(REQUESTIPRESERVATIONREQUEST_ONE_OF_SCHEMAS, const=True)

    class Config:
        validate_assignment = True

    @validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = cls()
        error_messages = []
        match = 0
        # validate data type: IPReservationRequestInput
        if type(v) is not IPReservationRequestInput:
            error_messages.append(f"Error! Input type `{type(v)}` is not `IPReservationRequestInput`")
        else:
            match += 1

        # validate data type: VrfIpReservationCreateInput
        if type(v) is not VrfIpReservationCreateInput:
            error_messages.append(f"Error! Input type `{type(v)}` is not `VrfIpReservationCreateInput`")
        else:
            match += 1

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into RequestIPReservationRequest with oneOf schemas: IPReservationRequestInput, VrfIpReservationCreateInput. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into RequestIPReservationRequest with oneOf schemas: IPReservationRequestInput, VrfIpReservationCreateInput. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: dict) -> RequestIPReservationRequest:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> RequestIPReservationRequest:
        """Returns the object represented by the json string"""
        instance = cls()
        error_messages = []
        match = 0

        # deserialize data into IPReservationRequestInput
        try:
            instance.actual_instance = IPReservationRequestInput.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))
        # deserialize data into VrfIpReservationCreateInput
        try:
            instance.actual_instance = VrfIpReservationCreateInput.from_json(json_str)
            match += 1
        except ValidationError as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into RequestIPReservationRequest with oneOf schemas: IPReservationRequestInput, VrfIpReservationCreateInput. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into RequestIPReservationRequest with oneOf schemas: IPReservationRequestInput, VrfIpReservationCreateInput. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_json()
        else:
            return "null"

    def to_dict(self) -> dict:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is not None:
            return self.actual_instance.to_dict()
        else:
            return dict()

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.dict())

